---------------------------------------------------------------
-- Universidade Federal de Pernambuco - UFPE
-- Centro de Informatica - CIn
-- Projeto: HPCIn
-- Coordenador: Manoel Eusebio
----------------------------------------------------------------
----------------------------------------------------------------
-- Modulo: mux_10_1.vhd
-- Descricao: 	Modulo responsavel por implementar um 
--				multiplexador 10-1
-- 
-- Autor(es): 	Victor Medeiros <victorwcm@gmail.com>
--				
-- Data de criacao: 31/07/08
----------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

-- definicao da entidade
entity mux_10_1 is 
	port (
		Psel		: in std_logic_vector(3 downto 0);
		Pinput_1	: in std_logic_vector(31 downto 0);
		Pinput_2	: in std_logic_vector(31 downto 0);
		Pinput_3	: in std_logic_vector(31 downto 0);
		Pinput_4	: in std_logic_vector(31 downto 0);
		Pinput_5	: in std_logic_vector(31 downto 0);
		Pinput_6	: in std_logic_vector(31 downto 0);
		Pinput_7	: in std_logic_vector(31 downto 0);
		Pinput_8	: in std_logic_vector(31 downto 0);
		Pinput_9	: in std_logic_vector(31 downto 0);
		Pinput_10	: in std_logic_vector(31 downto 0);
		Poutput		: out std_logic_vector(31 downto 0)
	);
end mux_10_1;

-- descricao da arquitetura comportamental da entidade
architecture arq_mux_10_1 of mux_10_1 is
	begin
		process (Psel, Pinput_1, Pinput_2, Pinput_3, Pinput_4, Pinput_5,
		         Pinput_6, Pinput_7, Pinput_8, Pinput_9, Pinput_10)
		begin
			case Psel is
				when "0000" => Poutput <= Pinput_1;
				when "0001" => Poutput <= Pinput_2;
				when "0010" => Poutput <= Pinput_3;
				when "0011" => Poutput <= Pinput_4;
				when "0100" => Poutput <= Pinput_5;
				when "0101" => Poutput <= Pinput_6;
				when "0110" => Poutput <= Pinput_7;
				when "0111" => Poutput <= Pinput_8;
				when "1000" => Poutput <= Pinput_9;
				when "1001" => Poutput <= Pinput_10;
				when others => Poutput <= x"FFFFFFFF";
			end case;
		end process;
end arq_mux_10_1;